/* 04jan14abu
 * (c) Software Lab. Alexander Burger
 */

function drawCanvas(id, dly, x, y) {
   var req = new XMLHttpRequest();

   try {
      req.open("POST",
         document.getElementsByTagName("BASE")[0].href + SesId +
         "!jsDraw?" + id + "&+" + dly +
         (y? "&+" + x + "&+" + y : x? "&" + x : "") );
      req.responseType = "arraybuffer";
   }
   catch (e) {return true;}
   req.onload = function() {
      var ele = document.getElementById(id);

      renderCanvas(ele, plio(new Uint8Array(req.response)));
      if (y)
         while (ele = ele.parentNode) {
            if (ele.tagName == "FORM") {
               post(ele, false, null, null);
               break;
            }
         }
      // if (dly == 0)
      //    requestAnimationFrame(function() {drawCanvas(id, dly)});
      // else if (dly > 0)
      //    setTimeout(function() {drawCanvas(id, dly)}, dly);
      if (dly >= 0)
         setTimeout(function() {drawCanvas(id, dly)}, dly);
   }
   try {req.send(null);}
   catch (e) {
      req.abort();
      return true;
   }
   return false;
}

function renderCanvas(cvs, lst) {
   var ctx = cvs.getContext("2d");
   var cmd, i, j;

   for (i = 0; i < lst.length; ++i) {
      switch ((cmd = lst[i])[0]) {  // Sync with "@lib/canvas.l"
      /*** Functions ***/
      case 1:  // (csFillText Str X Y)
         ctx.fillText(cmd[1], cmd[2], cmd[3]);
         break;
      case 2:  // (csStrokeLine X1 Y1 X2 Y2)
         ctx.beginPath();
         ctx.moveTo(cmd[1], cmd[2]);
         ctx.lineTo(cmd[3], cmd[4]);
         ctx.closePath();
         ctx.stroke();
         break;
      case 3:  // (csClearRect X Y DX DY)
         ctx.clearRect(cmd[1], cmd[2], cmd[3], cmd[4]);
         break;
      case 4:  // (csStrokeRect X Y DX DY)
         ctx.strokeRect(cmd[1], cmd[2], cmd[3], cmd[4]);
         break;
      case 5:  // (csFillRect X Y DX DY)
         ctx.fillRect(cmd[1], cmd[2], cmd[3], cmd[4]);
         break;
      case 6:  // (csBeginPath)
         ctx.beginPath();
         break;
      case 7:  // (csClosePath)
         ctx.closePath();
         break;
      case 8:  // (csMoveTo X Y)
         ctx.moveTo(cmd[1], cmd[2]);
         break;
      case 9:  // (csLineTo X Y)
         ctx.lineTo(cmd[1], cmd[2]);
         break;
      case 10:  // (csBezierCurveTo X1 Y1 X2 Y2 X Y)
         ctx.bezierCurveTo(cmd[1], cmd[2], cmd[3], cmd[4], cmd[5], cmd[6]);
         break;
      case 11:  // (csLine X1 Y1 X2 Y2)
         ctx.moveTo(cmd[1], cmd[2]);
         ctx.lineTo(cmd[3], cmd[4]);
         break;
      case 12:  // (csRect X Y DX DY)
         ctx.rect(cmd[1], cmd[2], cmd[3], cmd[4]);
         break;
      case 13:  // (csArc X Y R A B F)
         ctx.arc(cmd[1], cmd[2], cmd[3], cmd[4], cmd[5], cmd[6]);
         break;
      case 14:  // (csStroke)
         ctx.stroke();
         break;
      case 15:  // (csFill)
         ctx.fill();
         break;
      case 16:  // (csClip)
         ctx.clip();
         break;
      case 17:  // (csDef Key DX DY Lst)
         if (!cvs.pre)
            cvs.pre = new Array();
         var buf = cvs.pre[cmd[1]] = document.createElement('canvas');
         buf.width = cmd[2];
         buf.height = cmd[3];
         renderCanvas(buf, cmd[4]);
         break;
      case 18:  // (csDraw Key X Y)
         ctx.drawImage(cvs.pre[cmd[1]], cmd[2], cmd[3]);
         break;
      case 19:  // (csDrawDots DX DY Lst)
         if (cmd[3])
            for (j = 0; j < cmd[3].length; j += 2)
               ctx.fillRect(cmd[3][j], cmd[3][j+1], cmd[1], cmd[2]);
         break;
      case 20:  // (csDrawImage Img X Y)
         ctx.drawImage(cmd[1], cmd[2], cmd[3]);
         break;
      case 21:  // (csTranslate X Y)
         ctx.translate(cmd[1], cmd[2]);
         break;
      case 22:  // (csRotate A)
         ctx.rotate(cmd[1]);
         break;
      case 23:  // (csScale X Y)
         ctx.scale(cmd[1], cmd[2]);
         break;
      case 24:  // (csSave)
         ctx.save();
         break;
      case 25:  // (csRestore)
         ctx.restore();
         break;
      /*** Variables ***/
      case 26:  // (csFillStyle V)
         ctx.fillStyle = cmd[1];
         break;
      case 27:  // (csStrokeStyle V)
         ctx.strokeStyle = cmd[1];
         break;
      case 28:  // (csGlobalAlpha V)
         ctx.globalAlpha = cmd[1];
         break;
      case 29:  // (csLineWidth V)
         ctx.lineWidth = cmd[1];
         break;
      case 30:  // (csLineCap V)
         ctx.lineCap = cmd[1];
         break;
      case 31:  // (csLineJoin V)
         ctx.lineJoin = cmd[1];
         break;
      case 32:  // (csMiterLimit V)
         ctx.miterLimit = cmd[1];
         break;
      case 33:  // (csGlobalCompositeOperation V) )
         ctx.globalCompositeOperation = cmd[1];
         break;
      }
   }
}
